<?php
if ( ! class_exists( 'Charitable_Non_Profit_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Charitable_Non_Profit_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Charitable_Non_Profit_Plugin_Activation_WPElemento_Importer {

        private static $charitable_non_profit_instance;
        public $charitable_non_profit_action_count;
        public $charitable_non_profit_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$charitable_non_profit_instance) ) {
            self::$charitable_non_profit_instance = new self();
          }
          return self::$charitable_non_profit_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'charitable_non_profit_recommended_plugins', array($this, 'charitable_non_profit_recommended_elemento_importer_plugins_array') );

            $charitable_non_profit_actions                   = $this->charitable_non_profit_get_recommended_actions();
            $this->charitable_non_profit_action_count        = $charitable_non_profit_actions['count'];
            $this->charitable_non_profit_recommended_actions = $charitable_non_profit_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function charitable_non_profit_recommended_elemento_importer_plugins_array($charitable_non_profit_plugins){
            $charitable_non_profit_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'charitable-non-profit'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'charitable-non-profit'),               
            );
            return $charitable_non_profit_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'charitable-non-profit-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('charitable-non-profit-plugin-activation-script', 'charitable_non_profit_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'charitable-non-profit'),
                    'activating' => esc_html__('Activating', 'charitable-non-profit'),
                    'error' => esc_html__('Error', 'charitable-non-profit'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'charitable-non-profit-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function charitable_non_profit_get_recommended_actions() {

            $charitable_non_profit_act_count  = 0;
            $charitable_non_profit_actions_todo = get_option( 'recommending_actions', array());

            $charitable_non_profit_plugins = $this->charitable_non_profit_get_recommended_plugins();

            if ($charitable_non_profit_plugins) {
                foreach ($charitable_non_profit_plugins as $charitable_non_profit_key => $charitable_non_profit_plugin) {
                    $charitable_non_profit_action = array();
                    if (!isset($charitable_non_profit_plugin['slug'])) {
                        continue;
                    }

                    $charitable_non_profit_action['id']   = 'install_' . $charitable_non_profit_plugin['slug'];
                    $charitable_non_profit_action['desc'] = '';
                    if (isset($charitable_non_profit_plugin['desc'])) {
                        $charitable_non_profit_action['desc'] = $charitable_non_profit_plugin['desc'];
                    }

                    $charitable_non_profit_action['name'] = '';
                    if (isset($charitable_non_profit_plugin['name'])) {
                        $charitable_non_profit_action['title'] = $charitable_non_profit_plugin['name'];
                    }

                    $charitable_non_profit_link_and_is_done  = $this->charitable_non_profit_get_plugin_buttion($charitable_non_profit_plugin['slug'], $charitable_non_profit_plugin['name'], $charitable_non_profit_plugin['function']);
                    $charitable_non_profit_action['link']    = $charitable_non_profit_link_and_is_done['button'];
                    $charitable_non_profit_action['is_done'] = $charitable_non_profit_link_and_is_done['done'];
                    if (!$charitable_non_profit_action['is_done'] && (!isset($charitable_non_profit_actions_todo[$charitable_non_profit_action['id']]) || !$charitable_non_profit_actions_todo[$charitable_non_profit_action['id']])) {
                        $charitable_non_profit_act_count++;
                    }
                    $charitable_non_profit_recommended_actions[] = $charitable_non_profit_action;
                    $charitable_non_profit_actions_todo[]        = array('id' => $charitable_non_profit_action['id'], 'watch' => true);
                }
                return array('count' => $charitable_non_profit_act_count, 'actions' => $charitable_non_profit_recommended_actions);
            }

        }

        public function charitable_non_profit_get_recommended_plugins() {

            $charitable_non_profit_plugins = apply_filters('charitable_non_profit_recommended_plugins', array());
            return $charitable_non_profit_plugins;
        }

        public function charitable_non_profit_get_plugin_buttion($slug, $name, $function) {
                $charitable_non_profit_is_done      = false;
                $charitable_non_profit_button_html  = '';
                $charitable_non_profit_is_installed = $this->is_plugin_installed($slug);
                $charitable_non_profit_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $charitable_non_profit_is_activeted = (class_exists($function)) ? true : false;
                if (!$charitable_non_profit_is_installed) {
                    $charitable_non_profit_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $charitable_non_profit_plugin_install_url = wp_nonce_url($charitable_non_profit_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $charitable_non_profit_button_html        = sprintf('<a class="charitable-non-profit-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($charitable_non_profit_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'charitable-non-profit'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'charitable-non-profit')
                    );
                } elseif ($charitable_non_profit_is_installed && !$charitable_non_profit_is_activeted) {

                    $charitable_non_profit_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($charitable_non_profit_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $charitable_non_profit_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $charitable_non_profit_button_html = sprintf('<a class="charitable-non-profit-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($charitable_non_profit_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'charitable-non-profit'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'charitable-non-profit')
                    );
                } elseif ($charitable_non_profit_is_activeted) {
                    $charitable_non_profit_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'charitable-non-profit'));
                    $charitable_non_profit_is_done     = true;
                }

                return array('done' => $charitable_non_profit_is_done, 'button' => $charitable_non_profit_button_html);
            }
        public function is_plugin_installed($slug) {
            $charitable_non_profit_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $charitable_non_profit_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($charitable_non_profit_installed_plugins[$charitable_non_profit_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $charitable_non_profit_keys = array_keys($this->get_installed_plugins());
            foreach ($charitable_non_profit_keys as $charitable_non_profit_key) {
                if (preg_match('|^' . $slug . '/|', $charitable_non_profit_key)) {
                    return $charitable_non_profit_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Charitable_Non_Profit_Plugin_Activation_WPElemento_Importer::get_instance();